/* Console Commands
 *
 *
*/

#include <zephyr/shell/shell.h>
#include "../includes/RTCHelper.h"
#include "../includes/connectionManager.h"
#include "../includes/batteryCharger.h"
#include "../includes/MeasurementSystem.h"

//Network Manager Commands

SHELL_STATIC_SUBCMD_SET_CREATE(sub_conmanager,
    SHELL_CMD_ARG(connect, NULL, "Connect to LTE Network", __shell_CM_connect_to_Network, 1, 0),
    SHELL_CMD_ARG(info, NULL, "Get network info", __shell_CM_network_info, 1, 0),
    SHELL_CMD_ARG(timeSync, NULL, "ReSync RTC to network time", __shell_CM_syncTime, 1, 0),
    SHELL_SUBCMD_SET_END
);

SHELL_CMD_REGISTER(connection, &sub_conmanager, "Connection manager subsystem commands", NULL);

//RTC Commands
SHELL_STATIC_SUBCMD_SET_CREATE(sub_RTC, 
    SHELL_CMD_ARG(getTime, NULL, "Get epoch time from the RTC", __shell_RTC_Get_Time, 1, 0),
    SHELL_CMD_ARG(setTime, NULL, "Set the epoch time of the RTC", __shell_RTC_Set_Time,  2, 0),
    SHELL_CMD_ARG(enableCLKOut, NULL, "Enable Calibration Clock", __shell_RTC_EnableCLKOut, 1, 0),
    SHELL_CMD_ARG(disableCLKOut, NULL, "Disable Calibration Clock", __shell_RTC_DisableCLKOut, 1, 0),
    SHELL_CMD_ARG(DUMP, NULL, "Dump chip memory to console", __shell_RTC_DUMP, 1, 0),
    SHELL_CMD_ARG(alarmTest, NULL, "Perform alarm test", __shell_RTC_alarmTest, 1, 0),
    SHELL_SUBCMD_SET_END
);


SHELL_CMD_REGISTER(RTC, &sub_RTC, "RTC subsystem commands", NULL);

//Battery Charger Commands
SHELL_STATIC_SUBCMD_SET_CREATE(sub_batteryCharger,
    SHELL_CMD_ARG(dump, NULL, "Dump IC's memory to shell", __shell_Charger_Dump_Memory, 1, 0),
    SHELL_CMD_ARG(voltages, NULL, "Measure system voltages", __shell_Charger_Measure_Voltages,1, 0),
    SHELL_SUBCMD_SET_END
);
SHELL_CMD_REGISTER(charger, &sub_batteryCharger, "Battery charger commands", NULL);

//Measurement System Commands
SHELL_STATIC_SUBCMD_SET_CREATE(sub_MSR, 
    SHELL_CMD_ARG(dump, NULL, "Dump current measurement buffer to JSON", __shell_Dump_Measurements_to_Json, 1, 0),
    SHELL_CMD_ARG(primary, NULL, "Measure primvary board sensors", __shell_Measure_Primary_Board_Sensors, 1, 0),
    SHELL_CMD_ARG(count, NULL, "Get count of measurements currently in buffer", __shell_Measure_get_Count, 1, 0),
    SHELL_SUBCMD_SET_END
);

SHELL_CMD_REGISTER(MSR, &sub_MSR, "Measurement subsystem shell commands", NULL);