#include "../../includes/primaryBoardSensors.h"
#include <stdbool.h>

int __sensor_VBatt_measurement(sensorMeasurement *buffer);
int __sensor_VSys_measurement(sensorMeasurement *buffer);

Sensor sensor_VBatt = {
    .sensorID = BATTERY_CHARGER_VBATT_SENSOR_ID,
    .timeLastMeasured = 0,
    .updateInterval = SYSTEM_VOLTAGE_MEASUREMENT_INTERVAL,
    .powerOff = NULL,
    .powerOn = NULL,
    .configureSensor = NULL,
    .performMeasurement = __sensor_VBatt_measurement,
    .powered = true //Sensor permentantly on
};
Sensor sensor_VSys = {
    .sensorID = BATTERY_CHARGER_VSYS_SENSOR_ID,
    .timeLastMeasured = 0,
    .updateInterval = SYSTEM_VOLTAGE_MEASUREMENT_INTERVAL,
    .powerOff = NULL,
    .powerOn = NULL,
    .configureSensor = NULL,
    .performMeasurement = __sensor_VSys_measurement,
    .powered = true //Sensor permentantly on
};

//Measurement Functions
int __sensor_VBatt_measurement(sensorMeasurement *buffer){
    batteryCharger_ADC_Trigger();
    RTCgetTime(&(buffer->timeTaken));
    buffer->id = BATTERY_CHARGER_VBATT_SENSOR_ID;
    buffer->type = _MEASUREMENT_VOLTAGE;
    buffer->precision = 3;
    buffer->value = batteryCharger_Measure_Battery_Voltage();
    return 0;
}

int __sensor_VSys_measurement(sensorMeasurement *buffer){
    batteryCharger_ADC_Trigger();
    RTCgetTime(&(buffer->timeTaken));
    buffer->id = BATTERY_CHARGER_VSYS_SENSOR_ID;
    buffer->type = _MEASUREMENT_VOLTAGE;
    buffer->precision = 3;
    buffer->value = batteryCharger_Measure_Vsys_Voltage();
    return 0;
}
