#ifndef BATTERYCHARGER_H
#define BATTERYCHARGER_H

#include <stdbool.h>
#include <zephyr/shell/shell.h>
#include <zephyr/drivers/gpio.h>
#include "../includes/sensorMeasurement.h"
#include "../includes/boardDefine.h"

//Overview structure
struct _chargerState{
    bool chargingEnabled;
    bool mpptEnabled;
    bool adcEnabled;
};

// Battery Charger Stuff


extern struct _chargerState *chargerState;

void batteryCharger_ADC_Trigger();

//Value Measurement Functions
float batteryCharger_Measure_Battery_Voltage();
float batteryCharger_Measure_Vsys_Voltage();
float batteryCharger_Measure_Vac1_Voltage();

//Sensor implementation
int __batteryCharger_Perform_Measurement_VBATT(sensorMeasurement *buffer);
int __batteryCharger_Perform_Measurement_VSYS(sensorMeasurement *buffer);

//Initial state configuration helper
void batteryChargerInit();


//Shell commands
int __shell_Charger_Dump_Memory(const struct shell *sh, size_t argc, char **argv);
int __shell_Charger_Measure_Voltages(const struct shell *sh, size_t argc, char **argv);

#endif