#ifndef CONNECTIONMANAGER_H
#define CONNECTIONMANAGER_H

//Modem Libraries
#include <modem/lte_lc.h>
//Zephyr Libraries
#include <zephyr/shell/shell.h>
#include <net/azure_iot_hub.h>
//Modules
#include "RTCHelper.h"

//Overview Struct
struct _NetworkState{
    bool networkActive;
    bool networkInited;
    bool azureConnected;
    bool nrfCloudConnected;
};
extern struct _NetworkState *NetworkState;

//Network State commands
int Networkconnect();
void Network_initCloud();
void Network_ConnectToCloud();

//Network Function Commands
void NetworksyncRTCClockSNTP();

//Communication functions to work with the Connected cloud services
void Network_MeasurementToCloud(char *JsonString);
void Network_sendTo_Thingsboard(char *payload);

//Shell commands for Connection Manager
int __shell_CM_connect_to_Network(const struct shell *sh, size_t argc, char **argv);
int __shell_CM_network_info(const struct shell *sh, size_t argc, char **argv);
int __shell_CM_syncTime(const struct shell *sh, size_t argc, char **argv);

#endif